var buddyList;
var months = "Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec".split("|");
var audioscrobblerID = "";
var userInfo = "";
var aimfire = {
	chatWindows : new Array(),
	load : function() {
		buddyList = document.getElementById('buddyList');
		buddyList.view = buddyTree;

		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var prefBranch = prefs.getBranch("aimfire.");
		if (!prefBranch.prefHasUserValue("audioscrobblerID")) {
			prefBranch.setCharPref("audioscrobblerID", "");
			prefBranch.setCharPref("userInfo", "");
		} else {
			audioscrobblerID = prefBranch.getCharPref("audioscrobblerID");
			document.getElementById('audioscrobbler').value = audioscrobblerID;
			userInfo = prefBranch.getCharPref("userInfo");
		}
		if (!prefBranch.prefHasUserValue("proxymode"))
			prefBranch.setBoolPref("proxymode", false);
		else
			document.getElementById('proxy').checked = prefBranch.getBoolPref("proxymode");
	},
	login : function() {
		if (document.getElementById('username').value == 'about:mozilla') {
			window.openDialog("chrome://aimfire/content/welcomeDialog.xul","welcomeDialog",
			"screenY=0,screenX=0,width=500,height=500,chrome,modal=no,dialog=yes,resizable=yes");
			return;
		}
		audioscrobblerID = document.getElementById('audioscrobbler').value;
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var prefBranch = prefs.getBranch("aimfire.");
		prefBranch.setCharPref("audioscrobblerID", audioscrobblerID);
		prefBranch.setBoolPref("proxymode", document.getElementById('proxy').checked);
		if (true)	// (service == "AOL") XXX - later, in theory, we'll add support for more services
			mozillaTOC.login(document.getElementById('username').value, document.getElementById('password').value);
	},
	im : function(service, from, to, message, autoResponse) {
		var index = -1;
		for (var x = 0; x < this.chatWindows.length; ++x)
			if (this.chatWindows[x].from.toLowerCase() == from.toLowerCase()) {
				index = x;
				break;
			}

		if (index == -1) {
			var newWindow = window.openDialog("chrome://aimfire/content/chatWindow.xul","_blank",
						"screenY="+(document.getElementById('main-window').boxObject.height/2 - 45+document.getElementById('main-window').boxObject.screenY)
					  +",screenX="+(document.getElementById('main-window').boxObject.width/2 - 200+document.getElementById('main-window').boxObject.screenX)+
						",width=400,height=400,chrome,modal=no,dialog=no,resizable=yes",
						service, from, to, message);
			this.chatWindows.push(newWindow);
			index = this.chatWindows.length - 1;
		} else if (message != null)
			this.chatWindows[index].addMessage("<b><font color=\"#16569E\">" + from + "</font></b>", message, autoResponse);
	},
	setAwayMessage : function(sender) {
		mozillaTOC.setAway(!sender.checked ? "I'm not available right now." : "");
	},
	audioscrobblerLink : function() {
		window.open('http://www.audioscrobbler.com','Audioscrobbler');
	},
	aimfireLink : function () {
		window.open('http://aimfire.mozdev.org/donate.html','AIMfire');
	},
	rememberPassword : function() {
		var host = {value:""};		var username =  {value:""};		var password = {value:""};
		try {
			var passManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManagerInternal);

			passManager.findPasswordEntry("aim://", document.getElementById('username').value, "", host, username, password);

			document.getElementById('username').value = username.value;
			document.getElementById('password').value = password.value;
		} catch (ex) { }
	},
	savePassword : function() {
		var host = {value:""};	var login =  {value:""};	var password = {value:""};

		try {
			var formHistory = Components.classes["@mozilla.org/satchel/form-history;1"].getService(Components.interfaces.nsIFormHistory);
			formHistory.addEntry(document.getElementById('username').getAttribute("autocompletesearchparam"), document.getElementById('username').value);

			var passManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);
			var passManagerIn = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManagerInternal);
			passManager.addUser("aim://", document.getElementById('username').value, document.getElementById('password').value);
		} catch (ex) { }
	},
	cancel : function() {
		document.getElementById('connecting').collapsed = true;
		document.getElementById('statusmeter').setAttribute("mode", "determined");
		document.getElementById('login').collapsed = false;
	},
	closeWindow : function(window) {
		var index = -1;
		for (var x = 0; x < this.chatWindows.length; ++x)
			if (this.chatWindows[x] == window) {
				index = x;
				break;
			}
		if (index != -1)
			this.chatWindows.splice(index, 1);
	},
	close : function() {
		for (var x = 0; x < this.chatWindows.length; ++x)
			this.chatWindows[x].close();	// close all of the chat windows
		if (mozillaTOC.active)
			mozillaTOC.logout();
	},
};
