var service;// service you are connected to
var audioscrobbler = "";
var editor; // message editor
var atomizer = Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService).getAtom;
var fontSize = 3;

function load() {
	service = window.arguments[0];
	audioscrobbler = window.arguments[1];

	document.getElementById('message').makeEditable('html',false);
	editor = document.getElementById('message').getHTMLEditor(document.getElementById('message').contentWindow);
	editor.isCSSEnabled = false;
	document.getElementById('forecolor').color = "#000000";
}
function save() {
	var message = document.getElementById('message').contentWindow.document.body.innerHTML;
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	var prefBranch = prefs.getBranch("aimfire.");
	prefBranch.setCharPref("userInfo", message);
	if (audioscrobbler)
		message += "<br><a href='http://audioscrobbler.com/user/" + audioscrobbler + "'>Audioscrobbler Profile</a>"
	service.setInfo(message);
	this.close();
}
function testKey(event) {
	var atom, first = {}, any = {}, all = {};
	if (event.keyCode == 66 && event.ctrlKey)	{	// bold
		atom = atomizer('b');
		document.getElementById('bold').checked = !document.getElementById('bold').checked;
	} else if (event.keyCode == 73 && event.ctrlKey) {	// italic
		atom = atomizer('i');
		document.getElementById('italic').checked = !document.getElementById('italic').checked;
	} else if (event.keyCode == 85 && event.ctrlKey) {	// underline
		atom = atomizer('u');
		document.getElementById('underline').checked = !document.getElementById('underline').checked;
	} else
		return;

	editor.getInlineProperty(atom, '', '', first, any, all);
	if (first.value) {
		editor.removeInlineProperty(atom, '');
		editor.removeDefaultProperty(atomizer(atom), '', '');
	} else {
		editor.setInlineProperty(atom, '', '');
		editor.addDefaultProperty(atomizer(atom), '', '');
	}
}
function changeStyle(atom, sender) {
	if (!sender.checked) {
		editor.setInlineProperty(atomizer(atom), '', '');
		editor.addDefaultProperty(atomizer(atom), '', '');
	} else {
		editor.removeInlineProperty(atomizer(atom), '');
		editor.removeDefaultProperty(atomizer(atom), '', '');
	}
}
function updateFontSize() {
	fontSize = fontSize == 0 ? 1 : (fontSize > 7 ? 7 : fontSize);
	editor.setInlineProperty(atomizer('font'), 'size', fontSize);
}
